close all; 
clear; 
   
base_dir = '/rds/projects/h/hickeycm-naturaleeg/'; 

run('/rds/projects/2018/hickeycm-insense/MATLAB_toolboxes/CoSMoMVPA-master/mvpa/cosmo_set_path.m');
run('/rds/projects/2018/hickeycm-insense/MATLAB_toolboxes/eeglab14_1_2b/eeglab.m');
data_fold = [base_dir 'EEG_exp_Kisal/DATA'];

classify = {}; 
data = {}; 
partition = {};
subj_list = [1:32 34:37 39 41:43 46:49];

for subj_counter = 1:numel(subj_list)
    subj_num = subj_list(subj_counter)
    subj_str = ['P' sprintf('%02.f',subj_num)];
    save_fold = fullfile(data_fold,'F_classifications',subj_str);

    % targ
    load(fullfile(save_fold,[subj_str '_decode_4cat_2pos_exp_sl_targ_new.mat']));   

    classify_targ{subj_counter} = decode_res; 
    partition_targ{subj_counter} = partitions; 

    % should have never added the stupid RT field
    if isfield(ds.C1.a, 'RT')
        for i = 1:4
            field = ['C' num2str(i)];
            ds.(field).a = rmfield(ds.(field).a, 'RT')
        end
    end
        
    ds_test = cosmo_stack({ds.C1, ds.C2, ds.C3, ds.C4});
    data_targ{subj_counter} = ds_test; 

    % dist
    load(fullfile(save_fold,[subj_str '_decode_4cat_2pos_exp_sl_dist_new.mat']));
    classify_dist{subj_counter} = decode_res; 
    partition_dist{subj_counter} = partitions; 

    if isfield(ds.C1.a, 'RT')
        for i = 1:4
            field = ['C' num2str(i)];
            ds.(field).a = rmfield(ds.(field).a, 'RT')
        end
    end
            
    ds_test = cosmo_stack({ds.C1, ds.C2, ds.C3, ds.C4});
    data_dist{subj_counter} = ds_test; 

    % TL_DV
    load(fullfile(save_fold,[subj_str '_decode_4cat_2pos_exp_sl_LT_new.mat']));
    classify_LT{subj_counter} = decode_res; 
    partition_LT{subj_counter} = partitions; 
    
    if isfield(ds.LT_VD_C1.a, 'RT')
        for i = 1:4
            field = ['LT_VD_C' num2str(i)];
            ds.(field).a = rmfield(ds.(field).a, 'RT')
        end
    end
            
    ds_test = cosmo_stack({ds.LT_VD_C1, ds.LT_VD_C2, ds.LT_VD_C3, ds.LT_VD_C4});
    data_LT{subj_counter} = ds_test; 

    % DL_TV
    load(fullfile(save_fold,[subj_str '_decode_4cat_2pos_exp_sl_LD_new.mat']));
    classify_LD{subj_counter} = decode_res; 
    partition_LD{subj_counter} = partitions; 
    
    if isfield(ds.LD_VT_C1.a, 'RT')
        for i = 1:4
            field = ['LD_VT_C' num2str(i)];
            ds.(field).a = rmfield(ds.(field).a, 'RT')
        end
    end
            
    ds_test = cosmo_stack({ds.LD_VT_C1, ds.LD_VT_C2, ds.LD_VT_C3, ds.LD_VT_C4});
    data_LD{subj_counter} = ds_test; 

end

% % A9 A10 A11 / B5 B6 B7
left_electrodes = [9 10 11]; 
right_electrodes = [38 39 40]; 

timeline = ds_test.a.fdim.values{2}; 

[ipsicon_sample_targ, classify_sample_targ, classify_MI_targ] = signal_correlate(left_electrodes, right_electrodes, data_targ, classify_targ, partition_targ);
[ipsicon_sample_dist, classify_sample_dist, classify_MI_dist] = signal_correlate(left_electrodes, right_electrodes, data_dist, classify_dist, partition_dist);
[ipsicon_sample_LT, classify_sample_LT, classify_MI_LT] = signal_correlate(left_electrodes, right_electrodes, data_LT, classify_LT, partition_LT);
[ipsicon_sample_LD, classify_sample_LD, classify_MI_LD] = signal_correlate(left_electrodes, right_electrodes, data_LD, classify_LD, partition_LD);

save('F2_exp_corr_searchlight.mat', 'ipsicon_sample_targ', 'classify_sample_targ', ...
    'ipsicon_sample_dist', 'classify_sample_dist', 'ipsicon_sample_LT', ...
    'classify_sample_LT', 'ipsicon_sample_LD', 'classify_sample_LD', 'timeline', ...
    'classify_MI_targ', 'classify_MI_dist', 'classify_MI_LT', 'classify_MI_LD')

 




function [ipsicon_sample, classify_sample, classify_MI] = signal_correlate(left_electrodes, right_electrodes, data, classify, partition)
% this wrapper function for subject specific function makes parallel
% processing toolbox restrictions happy
    tic
    [ipsicon_sample, classify_sample, classify_MI] = deal(zeros(numel(data), numel(partition{1}.test_indices), 240)); 

    % for each subject
    parfor sub_counter = 1:numel(data)
        disp(sub_counter)
        [temp_ipsicon, temp_classify, temp_MI] = signal_correlate_subject(left_electrodes, right_electrodes, data{sub_counter}, classify{sub_counter}, partition{sub_counter});

        ipsicon_sample(sub_counter, :, :) = temp_ipsicon; 
        classify_sample(sub_counter, :, :) = temp_classify; 
        classify_MI(sub_counter, :, :) = temp_MI; 
    end
    toc
end


function [sub_ipsicon_sample, sub_classify_sample, sub_classify_MI] = signal_correlate_subject(left_electrodes, right_electrodes, sub_data, sub_classify, sub_partition)
    % for each partition within subject
    for partition_counter = 1:numel(sub_partition.test_indices)
        % select data in current partition
        working_data = cosmo_slice(sub_data, sub_partition.test_indices{partition_counter}); 
        % select left and right target data, save separately
        working_data_leftT = cosmo_slice(working_data, working_data.sa.position == 1); 
        working_data_rightT = cosmo_slice(working_data, working_data.sa.position == 2); 

        if any(isnan(working_data_leftT.samples),[1 2]) | any(isnan(working_data_rightT.samples), [1 2])
            disp('nan')
        end
    
        % channels vary first then samples
        % reshape fills rows first then generates new columns
        % cosmo format is instances, channels, time
        [a b] = size(working_data_leftT.samples); 
        c = b/128; 
        working_data_leftT.samples = reshape(working_data_leftT.samples, a, 128, c);
    
        [a b] = size(working_data_rightT.samples); 
        c = b/128; 
        working_data_rightT.samples = reshape(working_data_rightT.samples, a, 128, c);
    
        contra = (squeeze(mean(mean(working_data_leftT.samples(:,right_electrodes,:),1),2))...
            + squeeze(mean(mean(working_data_rightT.samples(:,left_electrodes,:),1),2)))./2;
    
        ipsi = (squeeze(mean(mean(working_data_leftT.samples(:,left_electrodes,:),1),2))...
            + squeeze(mean(mean(working_data_rightT.samples(:,right_electrodes,:),1),2)))./2;
    
        sub_ipsicon_sample(partition_counter,:) = contra - ipsi; 

        % mutual information
        sub_classify_MI(partition_counter,:) = sub_classify.MI(partition_counter,:); 

        % decoding accuracy
        sub_classify_sample(partition_counter,:) = sub_classify.samples2(partition_counter,:);
    end
end


